%this is the main entry code to compare different feature detectors 
%across different datasets and draws the curves and bars.
%it will call different feature detectors, calculate the repeatability scores
% and save them for the usage in Demo_show_results.m
%set flag_overwrite as true, so that data will be saved

clear;
close all;
addpath(genpath('..\Vessel_Feature_Detection_Share\'));%add with subfolder

%first set the corresponding flags
flag_overwrite=false;  %whether overwrite the existed data


method_done =  [1 2 17 6 3 7 4];%check the following code to see the meaning of each method
dataset_done =   [1 2 3 4 5];
data_path_all{1} = '..\Vessel_Dataset_Share\clip1';
data_path_all{2} = '..\Vessel_Dataset_Share\clip2';
data_path_all{3} = '..\Vessel_Dataset_Share\clip3';
data_path_all{4} = '..\Vessel_Dataset_Share\clip4';
data_path_all{5} = '..\Vessel_Dataset_Share\clip5';
data_path_curve = data_path_all{1};
data_path_repeatability_vs_points = data_path_all{1};
format = 'png';
thresh_specular=255;%choose not to remove specular for all methods

for dataset = dataset_done
    data_path = data_path_all{dataset};
    fprintf('Processing dataset %d***********************************************\n', dataset);
    for id_method = method_done
        data = compute_performance(id_method, data_path, format, thresh_specular, flag_overwrite);
    end
end







