
%this code shows the results in repeatability curves and bars
%the calculation of the data should have been done by Demo_run_evaluation.m

clear;
close all;
addpath(genpath('..\Vessel_Feature_Detection_Share\'));%add with subfolder

%first set the corresponding flags
flag_repeatability_vs_points = true; % whether to show the repeatability_vs_points curve
flag_plot_bars = true;       %whether to plot bars
flag_plot_curves = true;     %whether to plot repeatability curves

method_done =  [1 2 17 6 3 7 4];%check the following code to see the meaning of each method
dataset_done =   [1 2 3 4 5];
data_path_all{1} = '..\Vessel_Dataset_Share\clip1';
data_path_all{2} = '..\Vessel_Dataset_Share\clip2';
data_path_all{3} = '..\Vessel_Dataset_Share\clip3';
data_path_all{4} = '..\Vessel_Dataset_Share\clip4';
data_path_all{5} = '..\Vessel_Dataset_Share\clip5';
data_path_curve = data_path_all{1};
data_path_repeatability_vs_points = data_path_all{1};

%----------------------------calculate repeatability_vs_points------------%
if flag_repeatability_vs_points == true
    num_gap = 50;
    repeatability_sel=[];
    id_img = 3;
    for id_method = method_done
        str_id_method = int2str(id_method);
        name_points_repeatability = [data_path_repeatability_vs_points '\points_repeatability' str_id_method '.mat'];
        load(name_points_repeatability, 'points_prj2_all', 'feature_points2_all', 'Homo_all', 'thresh_distance_all', 'imsz1');
        feature_points2 = feature_points2_all{id_img};
        points_prj2 = points_prj2_all{id_img};
        Homo = Homo_all{id_img};
        thresh_distance = thresh_distance_all{id_img};
        num1 = size(points_prj2,2);
        num2 = size(feature_points2,1);
        for s=1:20
            num_select = s*50;
            if num1 > num_select
                ind_sel = randperm(num1);
                if id_method == 3 || id_method==4 ||  id_method==6 || id_method==7 || id_method==8
                    ind_sel = ind_sel(1:num_select);
                else
                    ind_sel = 1:num_select;
                end
                points_prj2_sel = points_prj2(:,ind_sel);
            else
                points_prj2_sel = points_prj2;
            end
            if  num2 > num_select
                ind_sel = randperm(num2);
                if id_method == 3 || id_method==4 ||  id_method==6 || id_method==7 || id_method==8
                    ind_sel = ind_sel(1:num_select);
                else
                    ind_sel = 1:num_select;
                end
                feature_points2_sel = feature_points2(ind_sel,:);
            else
                feature_points2_sel = feature_points2;
            end
            [~,~, ~, ~, ~, count_sel, count_valid_sel]...
                =calculate_repeatability(feature_points2_sel, points_prj2_sel, thresh_distance, imsz1, Homo);
            if count_valid_sel~=0
                repeatability_sel(s, id_method) = count_sel/min(count_valid_sel, num1); %each column is one method, each row is one number of features
            else
                repeatability_sel(s, id_method) = NaN;
            end
        end
    end
end

%-----------------------------set the curve formats-----------------------%
rgb_line(1,:)=[65,105,225]/255;  rgb_markeredge(1,:)=[50,205,50]/255;  rgb_markerface(1,:)=[255,255,255]/255;  marker{1}='o-';      %branch
rgb_line(2,:)=[255,69,0]/255;  rgb_markeredge(2,:)=[50,205,50]/255;  rgb_markerface(2,:)=[50,205,50]/255;    marker{2}='o-';        %ridge
rgb_line(3,:)=[154,205,50]/255;rgb_markeredge(3,:)=[123,104,238]/255;  rgb_markerface(3,:)=[123,104,238]/255;  marker{3}='*-';      %sift
rgb_line(4,:)=[32,178,170]/255;  rgb_markeredge(4,:)=[255,182,193]/255;  rgb_markerface(4,:)=[255,182,193]/255;    marker{4}='^-';  %fast
rgb_line(5,:)=[255,204,153]/255;  rgb_markeredge(5,:)=[165,42,42]/255;  rgb_markerface(5,:)=[165,42,42]/255;  marker{5}='x-';       %sofka
rgb_line(6,:)=[204,153,255]/255;  rgb_markeredge(6,:)=[255,99,71]/255;  rgb_markerface(6,:)=[255,99,71]/255;  marker{6}='>-';       %annisotropic
rgb_line(7,:)=[205,204,204]/255;  rgb_markeredge(7,:)=[154,205,50]/255;  rgb_markerface(7,:)=[255,255,255]/255;  marker{7}='+-';    %Hessian
rgb_line(8,:)=[245,222,179]/255;  rgb_markeredge(8,:)=[255,165,0]/255;  rgb_markerface(8,:)=[255,255,255]/255;  marker{8}='<-';     %HessianLaplace
rgb_line(9,:)=[51,102,0]/255; rgb_markeredge(9,:)=[50,205,50]/255; rgb_markerface(9,:)=[51,102,0]/255; marker{9}='-s';              %Harris
rgb_line(10,:)=[255,153,255]/255; rgb_markeredge(10,:)=[50,205,50]/255; rgb_markerface(10,:)=[255,153,255]/255; marker{10}='-s';    %ShiTomashi
rgb_line(16,:)=[244,164,96]/255;  rgb_markeredge(16,:)=[148,0,211]/255;  rgb_markerface(16,:)=[148,0,211]/255;    marker{16}='<-';  %VBSD
rgb_line(17,:)=[148,0,211]/255;  rgb_markeredge(17,:)=[64,224,208]/255;  rgb_markerface(17,:)=[64,224,208]/255;    marker{17}='o-'; %RBSD
str_legend = {'VBCT', 'RBCT', 'SIFT', 'FAST', 'Sofka', 'AFD', 'Hessian', 'HessianLaplace', 'Harris', 'ShiTomashi','*','*','*','*','*', 'VBSD', 'RBSD'};

%-----------------------------plotting repeatability curves---------------%
repeatability=[];
err_mean=[];
variance=[];
num_correct=[];
num_total_match=[];
correctness=[];
num_fp1=[];
num_fp2=[];
err_mean_table=[];
variance_table=[];
num_correct_table=[];
num_fp2_table=[];
if flag_calculation == false && flag_plot_curves == true;
    name_statistics = [data_path_curve '\Statistics.txt'];
    Statistics = dlmread(name_statistics); 
    homo_error_mean = mean(Statistics(:,3))
    homo_error_var = mean(Statistics(:,4))
    num_img = sum(Statistics(:,1));
    for id_method = method_done
        str_id_method = int2str(id_method);
        name_data_save = [data_path_curve '\data_method' str_id_method '.txt'];
        data = dlmread(name_data_save);
        %data_all(:,:,id_method) = data;
        repeatability(:,id_method)=data(1:num_img,1);%each column is one method, each row is one image
        err_mean(:,id_method)=data(1:num_img,2);
        variance(:,id_method)=data(1:num_img,3);
        num_correct(:,id_method)=data(1:num_img,4);
        num_total_match(:,id_method)=data(1:num_img,5);
        correctness(:,id_method)=data(1:num_img,6);
        num_fp1(:,id_method)=data(1:num_img,7);
        num_fp2(:,id_method)=data(1:num_img,8);
        err_mean_table(1,id_method) = mean(data(1:5,2));
        variance_table(1,id_method) = mean(data(1:5,3));
        num_correct_table(1,id_method) = mean(data(1:5,4));
        num_fp2_table(1,id_method) = mean(data(1:5,8));
    end
    disp('err_mean_table'); err_mean_table
    disp('variance_table'); variance_table
    disp('num_correct_table'); num_correct_table
    disp('num_fp2_table'); num_fp2_table
    num_img_show = min(num_img, size(repeatability,1));
    figure(1);
    %title('Repeatability over view points.')
    hold on;
    xlabel('Frame number', 'FontSize', 13);
    ylabel('Repeatability', 'FontSize', 13);
    for id_method = method_done
        plot(1:num_img_show, repeatability(1:num_img_show,id_method), marker{id_method}, 'Color', rgb_line(id_method,:), 'LineWidth', 1.5, 'MarkerSize', 8,  'MarkerEdgeColor', rgb_markeredge(id_method,:), 'MarkerFaceColor', rgb_markerface(id_method,:));
    end
    legend(str_legend(method_done));%---------------------------------------
    figure(2);
   % title('Mean error of detectors.')
    xlabel('Frame number', 'FontSize', 13);
    ylabel('Location error', 'FontSize', 13);
    hold on;
    for id_method = method_done
        plot(1:num_img_show, err_mean(1:num_img_show,id_method), marker{id_method}, 'Color', rgb_line(id_method,:), 'LineWidth', 1.5, 'MarkerSize', 8,  'MarkerEdgeColor', rgb_markeredge(id_method,:), 'MarkerFaceColor', rgb_markerface(id_method,:));
    end
    %legend(str_legend(method_done));
    figure(3);
   %title('Variance of error of detectors.')
    xlabel('Frame number', 'FontSize', 13);
    ylabel('Variance', 'FontSize', 13);
    hold on;
    for id_method = method_done
        plot(1:num_img_show, variance(1:num_img_show,id_method), marker{id_method}, 'Color', rgb_line(id_method,:), 'LineWidth', 1.5, 'MarkerSize', 8,  'MarkerEdgeColor', rgb_markeredge(id_method,:), 'MarkerFaceColor', rgb_markerface(id_method,:));
    end
    %legend(str_legend(method_done));
    figure(4);
    %title('Number of feature points detected in each image.')
    xlabel('Frame number', 'FontSize', 13);
    ylabel('Number of feature points', 'FontSize', 13);
    hold on;
    for id_method = method_done
        plot(1:num_img_show, num_fp2(1:num_img_show,id_method), marker{id_method}, 'Color', rgb_line(id_method,:), 'LineWidth', 1.5, 'MarkerSize', 8,  'MarkerEdgeColor', rgb_markeredge(id_method,:), 'MarkerFaceColor', rgb_markerface(id_method,:));
    end
    %legend(str_legend(method_done));
    if flag_repeatability_vs_points == true
        figure(5);
        %title('Repeatability over number of feature points.')
        xlabel('Number of feature points', 'FontSize', 13);
        ylabel('Repeatability', 'FontSize', 13);
        hold on;
        for id_method = method_done
            plot(num_gap:num_gap:size(repeatability_sel,1)*num_gap, repeatability_sel(:,id_method), marker{id_method}, 'Color', rgb_line(id_method,:), 'LineWidth', 1.5, 'MarkerSize', 8,  'MarkerEdgeColor', rgb_markeredge(id_method,:), 'MarkerFaceColor', rgb_markerface(id_method,:));
        end
    end
    %legend(str_legend(method_done));
    figure(6);
    %title('Correctness of SSD matching.')
    xlabel('Frame number', 'FontSize', 13);
    ylabel('Correctness', 'FontSize', 13);
    hold on;
    for id_method = method_done
        plot(1:num_img_show, correctness(1:num_img_show,id_method), marker{id_method}, 'Color', rgb_line(id_method,:), 'LineWidth', 1.5, 'MarkerSize', 8,  'MarkerEdgeColor', rgb_markeredge(id_method,:), 'MarkerFaceColor', rgb_markerface(id_method,:));
    end
    legend(str_legend(method_done));  
end

%-----------------------------plotting bars-------------------------------%
if flag_calculation == false && flag_plot_bars == true
    %first load all data
    for dataset = dataset_done
        clear repeatability err_mean variance num_fp1 num_fp2 correctness
        data_path = data_path_all{dataset};
        name_statistics = [data_path '\Statistics.txt'];
        Statistics = dlmread(name_statistics); 
        num_img = sum(Statistics(:,1));
        for id_method = method_done
            str_id_method = int2str(id_method);
            name_data_save = [data_path '\data_method' str_id_method '.txt'];
            data = dlmread(name_data_save);
            %data_all(:,:,id_method) = data;
            repeatability(:,id_method)=data(1:num_img,1);
            err_mean(:,id_method)=data(1:num_img,2);
            variance(:,id_method)=data(1:num_img,3);
            num_fp1(:,id_method)=data(1:num_img,7);
            num_fp2(:,id_method)=data(1:num_img,8);
            correctness(:,id_method)=data(1:num_img,6);
        end
        repeatability_mean(dataset,:) = mean(repeatability);%each row is a dataset
        repeatability_var(dataset,:) = var(repeatability);
        num_fp2_mean(dataset,:) = mean(num_fp2);
        correctness_mean(dataset,:) = mean(correctness);
        correctness_var(dataset,:) = var(correctness);
    end
    repeatability_overall = mean(repeatability_mean(dataset_done,:),1);
    correctness_overall = mean(correctness_mean(dataset_done,:),1);
    num_fp2_overall = mean(num_fp2_mean(dataset_done,:),1);
    dataset_done(end+1) = 8;
    repeatability_mean(8,:) = repeatability_overall;
    correctness_mean(8,:) = correctness_overall;
    num_fp2_mean(8,:) = num_fp2_overall;
    str_xlabel={'scene1', 'scene2', 'scene3', 'scene4', 'scene5', 'scene6', 'scene7', 'overall'};
    %then draw the bars
    %-------draw repeatability--------------------
    figure(9);
    bar(repeatability_mean(dataset_done,method_done));
    %title('Comparison of repeatability','FontSize', 13);
    legend(str_legend(method_done));
    ylabel('Repeatability', 'FontSize', 15);
    set(gca,'XTickLabel',str_xlabel(dataset_done),'FontSize', 15);
    %-------draw number of feature points---------
    figure(10);
    bar(num_fp2_mean(dataset_done,method_done([1 2 4 5 6 7])));%cause 17 is not compared
    %title('Comparison of number of feature points','FontSize', 13);
    legend(str_legend(method_done([1 2 4 5 6 7])));
    ylabel('Number of feature points', 'FontSize', 15);
    set(gca,'XTickLabel',str_xlabel(dataset_done),'FontSize', 15)
    %-------draw correctness---------
    figure(11);
    bar(correctness_mean(dataset_done,method_done));
    %title('Comparison of patch matching correctness','FontSize', 13);
    legend(str_legend(method_done));
    ylabel('Patch matching correctness', 'FontSize', 15);
    set(gca,'XTickLabel',str_xlabel(dataset_done),'FontSize', 15)
end



    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    






