function [H_optimal,score_max, err_mean_min, err_optimal]=homo_ransac(X1, X2, numMatches, flag_has_outlier)
%X2=H*X1
clear H score ok ;
score_max = 0;
err_mean_min = 10000;
thresh_inlier = 2;%this is adjustable
for t = 1:1000
    % estimate homograpyh
    subset = vl_colsubset(1:numMatches, 4) ;
    A = [] ;
    for i = subset
    A = cat(1, A, kron(X1(:,i)', vl_hat(X2(:,i)))) ;
    end
    [U,S,V] = svd(A) ;
    H = reshape(V(:,9),3,3) ;

    % score homography
    X2_ = H * X1 ;
    du = X2_(1,:)./X2_(3,:) - X2(1,:)./X2(3,:) ;
    dv = X2_(2,:)./X2_(3,:) - X2(2,:)./X2(3,:) ;
    err = sqrt(du.*du + dv.*dv);
    ok = err < thresh_inlier ;
    score = sum(ok);%number of inlier
    if flag_has_outlier == false%minimize the mean error
        err_mean = sum(err)/numMatches;
        if err_mean < err_mean_min
            err_mean_min = err_mean;
            H_optimal = H;
            err_optimal = err;
        end
    else%maximize the number of inlier
        if score > score_max
            score_max=score;
            H_optimal = H;
            err_optimal = err;
        end
    end
end

H_optimal = H_optimal / H_optimal(3,3) ;



end