function [feature_points, segments, segments_half, segments_fp_index, segments_half_fp_index]=detector_RBSD(I, radius, thresh_specular)
%this is the entry function of vessel feature detection using RBCT and RBSD
%input: 
%     I: image
%     radius: radius of circle used in circle test
%     thresh_specular: threshold of specular reflection
%output:
%    segments: {k}n*2  k number of segments, each cell contains a segment, each row [x,y] is a point. first
%        rwo is head feature point, last row is tail feature point
%    segments_fp_index: n*2 the index of feature points in the corresponding
%        segment in feature_points
%    segments_half: m*2 segments_half_fp_index  same thing as above but
%    for segment which only have one end as feature point
%    segments_fp_index: n*2 the index of feature points in the corresponding segment in feature_points
%    segments_half_fp_index: same thing as above
flag_show_results=true;
img_ori = I;
if max(max(max(I)))>=1
    I=im2double(I);
end
if(size(I,3)>1) 
    I=I(:,:,2);%use green channel
end
%detect ridgeness
[Iridge, muSmall, hesssian_angle] = ridgeness(I, thresh_specular);
%RBCT detect branching points
[feature_points, ridges] = RBCT(Iridge, radius, muSmall);
%RBSD detect branching segments
[segments, segments_half, segments_fp_index, segments_half_fp_index]=RBSD(Iridge, feature_points, ridges, hesssian_angle);

if flag_show_results==true
    h=figure(1);
    imshow(img_ori);
    display_vessegment(h, segments, segments_half);
end