function [Iridge, DoH, hesssian_angle] = ridgeness(I, thresh_specular)
%input: 
%     I: image
%     thresh_specular: threshold of specular reflection [0 255]
%output:
%     Iridge: ridgeness image
%     DoH: determinant of Hessian: lambda1*lambda2
%     hesssian_angle: angle of eigenvector (smallest eigenvalue, along vessel), obtained from atan2, use cos and sin to recover. 

if ~exist('thresh_specular', 'var')
    thresh_specular = 170;
end
if(size(I,3)>1) 
    I=I(:,:,2);%using green channel
end
I=double(I);
[I, mask_spec]=remove_specular(I, thresh_specular);%not stable, choose not use for now
I=I/max(max(I)); %convert to [0, 1]
[Ivessel, scale, hesssian_angle, DoH]=FrangiFilter2D(I);
sigma = 2.0;
Iridge = calc_ridgeness(I, Ivessel, sigma, hesssian_angle);








