function [isbranch, ridge] = circle_test_vesselness(distribution, val_center)
%find the ridges and check whether it satisfies the branch pattern check
%
%TODO: explicitely calculate the bottom pixels and enforce the peak to have
%certain height
%TODO: similar value distribution(1) > val_center-thresh_similar
isbranch=false;
ridge(1)=-1;
num = length(distribution);
k=1;
thresh_similar = 0.03;% center - p < 0.02
thresh_black = 0.005; %less than 0.001 is black pixel
thresh_bright = 0.02;
thresh_ratio_peaks = 1/10;
thresh_monotonic = 0.0001;
thresh_peak_height = 0.005;
thresh_min_peak=0.02;%this is very sensitive, pay attention
if distribution(num-1)+thresh_monotonic<distribution(num) && distribution(num)+thresh_monotonic<distribution(1) ...
        && distribution(1)>distribution(2)+thresh_monotonic && distribution(2)>distribution(3)+thresh_monotonic...
        && distribution(1) > thresh_min_peak %the peak should be bright
    ridge(k)=1;
    
    k=k+1;
end
if distribution(num)+thresh_monotonic<distribution(1) && distribution(1)+thresh_monotonic<distribution(2) ...
        && distribution(2)>distribution(3)+thresh_monotonic && distribution(3)>distribution(4)+thresh_monotonic...
        && distribution(2) > thresh_min_peak
    ridge(k)=2;
    k=k+1;
end

for i=3:num-2
    p1=distribution(i-2);
    p2=distribution(i-1);
    p3=distribution(i);
    p4=distribution(i+1);
    p5=distribution(i+2);
    if p1+thresh_monotonic < p2 && p2+thresh_monotonic < p3 && p3 > p4+thresh_monotonic && p4 > p5+thresh_monotonic && p3 > thresh_min_peak
        ridge(k)=i;
        k=k+1;
    end
end

if distribution(num-3)+thresh_monotonic<distribution(num-2) && distribution(num-2)+thresh_monotonic<distribution(num-1) ...
        && distribution(num-1)>distribution(num)+thresh_monotonic && distribution(num)>distribution(1)+thresh_monotonic...
        && distribution(num-1) > thresh_min_peak
    ridge(k)=num-1;
    k=k+1;
end
if distribution(num-2)+thresh_monotonic<distribution(num-1) && distribution(num-1)+thresh_monotonic<distribution(num) ...
        && distribution(num)>distribution(1)+thresh_monotonic && distribution(1)>distribution(2)+thresh_monotonic...
        && distribution(num) > thresh_min_peak
    ridge(k)=num;
    k=k+1;
end
num_peak=k-1;% now k==length(ridge);

count=1;
ridge_final=[];
if num_peak>=3
    %2.peak should start and end with dark pixels
    %3.peak should have enough height
    %figure(5); plot(1:length(distribution),distribution,'*');
    for i=2:num_peak-1
        start = floor((ridge(i-1)+ridge(i))/2);
        tail = floor((ridge(i)+ridge(i+1))/2);
        if distribution(start) < thresh_bright && distribution(tail) < thresh_bright && distribution(ridge(i))-max(distribution(start),distribution(tail))>thresh_peak_height
            ridge_final(count)=ridge(i);
            count=count+1;
        end
    end
    start = floor((ridge(num_peak)+ridge(1)+num)/2);
    if start>num 
        start=start-num;
    end
    tail = floor((ridge(1)+ridge(2))/2);
    if distribution(start) < thresh_bright && distribution(tail) < thresh_bright && distribution(ridge(1))-max(distribution(start),distribution(tail))>thresh_peak_height
        ridge_final(count)=ridge(1);
        count=count+1;
    end
    start = floor((ridge(num_peak-1)+ridge(num_peak))/2);
    tail = floor((ridge(num_peak)+ridge(1)+num)/2);
    if start>num 
        start=start-num;
    end
    if tail>num 
        tail=tail-num;
    end
    if distribution(start) < thresh_bright && distribution(tail) < thresh_bright && distribution(ridge(num_peak))-max(distribution(start),distribution(tail))>thresh_peak_height
        ridge_final(count)=ridge(num_peak);
        count=count+1;
    end
end
num_peak = length(ridge_final);

if num_peak<3
    return;  %if less than 3 peaks
end

peaks = distribution(ridge_final);
p_min = min(peaks);
p_max = max(peaks);
%peaks should be bright
%peaks should have similar brightness
%peaks shuold have similar brightness as the center
if ~(p_min > thresh_min_peak && p_min/p_max>thresh_ratio_peaks)
    return;
end

isbranch = true;%



