function [feature_points, ridges, Ivessel] = detector_VBCT(I, radius, thresh_specular)
%input: I: image
%       radius: n*1 radius used of circles used in VBCT
%       thresh_specular: threshold of specular reflection in range [0 255]
%out:
%        feature_points: n*3, 1st for x, 2nd for y, 3rd for score, which is the number of points in the connected component
%        ridges: cell n*1, each cell contains the ridge points associated
%           with the branch point, same format as connected_peaks
flag_show_results=true;
img_ori = I;
if max(max(max(I)))>=1
    I=im2double(I);
end
if(size(I,3)>1) 
    I=I(:,:,2);%using green channel
end
I=double(I);
[I, mask_spec]=remove_specular(I, thresh_specular);
I=I/max(max(I)); %convert to [0, 1]
options = struct('FrangiScaleRange', [3 5], 'FrangiScaleRatio', 1, 'FrangiBetaOne', 0.5, 'FrangiBetaTwo', 15, 'verbose',true,'BlackWhite',true);
%be reminded that scale in vesselness is actually the sigma (standard deviation) of gaussian kernal
[Ivessel, scale, hesssian_angle, DoH]=FrangiFilter2D(I, options);
%detect branching point: VBCT
[feature_points, ridges]=VBCT(Ivessel, radius, DoH);

if flag_show_results==true
    figure(1);
    imshow(img_ori);
    hold on;
    plot(feature_points(:,1), feature_points(:,2),'og');
end


