function [feature_points, segments, segments_half, segments_fp_index, segments_half_fp_index, Ivessel] = detector_VBSD(I, radius, thresh_specular)
%input: I: image
%       radius: n*1 radius used of circles used in VBCT
%       thresh_specular: threshold of specular reflection in range [0 255]
%out:
%        feature_points: n*3, 1st for x, 2nd for y, 3rd for score, which is the number of points in the connected component
%        segments: k*1 cells and each cell is n*2  k number of segments, each cell contains a segment, each row [x,y] is a point. first
%                  row is head feature point, last row is tail feature point
%        segments_half: k cells, each cell is m*2, only the first row is head feature point
%        segments_fp_index: n*2 the index of feature points in the corresponding segment in feature_points
%        segments_half_fp_index: same thing as above
flag_show_results=true;
img_ori = I;
if max(max(max(I)))>=1
    I=im2double(I);
end
if(size(I,3)>1) 
    I=I(:,:,2);%using green channel
end
I=double(I);
[I, mask_spec]=remove_specular(I, thresh_specular);
I=I/max(max(I)); %convert to [0, 1]
options = struct('FrangiScaleRange', [3 5], 'FrangiScaleRatio', 1, 'FrangiBetaOne', 0.5, 'FrangiBetaTwo', 15, 'verbose',true,'BlackWhite',true);
%be reminded that scale in vesselness is actually the sigma (standard deviation) of gaussian kernal
[Ivessel, scale, hesssian_angle, DoH]=FrangiFilter2D(I, options);
%detect branching point: VBCT
[feature_points, ridges]=VBCT(Ivessel, radius, DoH);
%detect branching segments: VBSD
[segments, segments_half, segments_fp_index, segments_half_fp_index]=VBSD(Ivessel, feature_points, ridges, hesssian_angle);

if flag_show_results==true
    h=figure(1);
    imshow(img_ori);
    display_vessegment(h, segments, segments_half);
end


