function [repeatability, num_seg_repeat]=branching_segment_match(match, feature_points1, segments1, segments_half1, segments_fp_index1, ...
    segments_half_fp_index1, feature_points2, segments2, segments_half2,  segments_fp_index2, segments_half_fp_index2, I, J, Homo)
%matching branching segments
%match: n*2, n the number of matches, 1st index of feat. in image1, 2nd image2
flag_segment_visualization=true;
flag_debug = false;
flag_seg_half_debug=false;
num_fp1=size(feature_points1,1);
num_seg1=size(segments1,2);
num_seg_half1=size(segments_half1,2);
num_fp2=size(feature_points2,1);
num_seg2=size(segments2,2);
num_seg_half2=size(segments_half2,2);
num_match = size(match,1);
fp1_to_fp2 = zeros(num_fp1,1);
fp1_to_fp2(match(:,1),1)=match(:,2);
fp2_to_fp1 = zeros(num_fp2,1);
fp2_to_fp1(match(:,2),1)=match(:,1);
segment_mask2 = zeros(num_fp2,num_fp2);
for i=1:num_seg2
    head = segments_fp_index2(i,1);
    tail = segments_fp_index2(i,2);
    segment_mask2(head, tail)=i;
    segment_mask2(tail, head)=i;
end
segment_mask1 = zeros(num_fp1,num_fp1);
for i=1:num_seg1
    head = segments_fp_index1(i,1);
    tail = segments_fp_index1(i,2);
    segment_mask1(head, tail)=i;
    segment_mask1(tail, head)=i;
end
num_seg_repeat=0;
close all;
figure(1);
imshow(I);
imsz=size(I);
set(gca,'Units','normalized','Position',[0 0 1 1]);
set(gcf,'Units','pixels','Position',[0 0 imsz(2) imsz(1)]);
figure(2);
imshow(J);
imsz=size(J);
set(gca,'Units','normalized','Position',[0 0 1 1]);
set(gcf,'Units','pixels','Position',[0 0 imsz(2) imsz(1)]);
%draw full and half segments
if flag_segment_visualization == true
    figure(1);
    imshow(I);
    hold on;
    for i=1:num_seg_half1
        one_seg = segments_half1{i};
        plot(one_seg(:,1), one_seg(:,2), '.', 'Color', [65,105,225]/255);
        plot(one_seg(1,1), one_seg(1,2), 'o', 'Color', [255,69,0]/255, 'MarkerSize', 8, 'LineWidth', 2, 'MarkerFace', [255,69,0]/255);
    end
    for i=1:num_seg1
        one_seg = segments1{i};
        plot(one_seg(:,1), one_seg(:,2), '.', 'Color', [218,112,214]/255);%[50,205,50]
        plot(one_seg(1,1), one_seg(1,2), '*', 'Color',  [0,255,255]/255, 'MarkerSize', 8, 'LineWidth', 2, 'MarkerFace', [0,255,255]/255);
        plot(one_seg(end,1), one_seg(end,2), '*', 'Color', [0,255,255]/255, 'MarkerSize', 8, 'LineWidth', 2, 'MarkerFace', [0,255,255]/255);
    end
    figure(2);
    imshow(J);
    hold on;
    for i=1:num_seg_half2
        one_seg = segments_half2{i};
        plot(one_seg(:,1), one_seg(:,2), '.', 'Color', [65,105,225]/255);
        plot(one_seg(1,1), one_seg(1,2), 'o', 'Color', [255,69,0]/255, 'MarkerSize', 8, 'LineWidth', 2, 'MarkerFace', [255,69,0]/255);
    end
    for i=1:num_seg2
        one_seg = segments2{i};
        plot(one_seg(:,1), one_seg(:,2), '.', 'Color', [218,112,214]/255);%[50,205,50]
        plot(one_seg(1,1), one_seg(1,2), 'o', 'Color',  [0,255,255]/255, 'MarkerSize', 8, 'LineWidth', 2, 'MarkerFace', [0,255,255]/255);
        plot(one_seg(end,1), one_seg(end,2), 'o', 'Color', [0,255,255]/255, 'MarkerSize', 8, 'LineWidth', 2, 'MarkerFace', [0,255,255]/255);
    end
end

imsz1=size(I);
flag_show_boundary=false;
count_seg_valid2=0;
gap=5;
Homo_inv = inv(Homo);
for i=1:num_seg2%scaning each segment in img2
    head2=segments_fp_index2(i,1);
    tail2=segments_fp_index2(i,2);
    head1 = fp2_to_fp1(head2);
    tail1 = fp2_to_fp1(tail2);
%---------make sure the points are visible in img1------------------------
    px_head=feature_points2(head2,1);
    py_head=feature_points2(head2,2);
    px_tail=feature_points2(tail2,1);
    py_tail=feature_points2(tail2,2);
    p2 = [px_head; py_head; 1];
    p1 = Homo_inv*p2;
    p1 = p1/p1(3);
    if p1(1)<=8*gap || p1(1)>=imsz1(2)-8*gap || p1(2)<=gap || p1(2)>=imsz1(1)-gap%if points are too close to the boundary
        if flag_show_boundary == true
            figure(2);
            hold on;
            plot(px_head, py_head, '^r');
        end
        continue;
    end
    p2 = [px_tail; py_tail; 1];
    p1 = Homo_inv*p2;
    p1 = p1/p1(3);
    if p1(1)<=8*gap || p1(1)>=imsz1(2)-8*gap || p1(2)<=gap || p1(2)>=imsz1(1)-gap%if points are too close to the boundary
        if flag_show_boundary == true
            figure(2);
            hold on;
            plot(px_tail, py_tail, '^r');
        end
        continue;
    end
    count_seg_valid2 = count_seg_valid2 +1;
%--------------------------check if match and if segment------------------
    if head1>0 && tail1>0 %ensure ith point in img2 has a match in img1
        tag=segment_mask1(head1,tail1);%check if this is also a segment in img1
        if tag>0 
            num_seg_repeat=num_seg_repeat+1;
            match_segment(num_seg_repeat,1)=tag;%img1
            match_segment(num_seg_repeat,2)=i;  %img2
            match_segment(num_seg_repeat,3)=head1;
            match_segment(num_seg_repeat,4)=tail1;
            match_segment(num_seg_repeat,5)=head2;
            match_segment(num_seg_repeat,6)=tail2;
            if flag_debug == true
                one_seg = segments1{tag};
                one_seg2 = segments2{i};
                figure(1);
                hold on;
                plot(one_seg(:,1), one_seg(:,2), '.', 'Color', [50,205,50]/255);
                plot(one_seg(1,1), one_seg(1,2), 'o', 'Color',  [0,255,255]/255, 'MarkerSize', 8, 'LineWidth', 2, 'MarkerFace', [0,255,255]/255);
                plot(one_seg(end,1), one_seg(end,2), 'o', 'Color', [0,255,255]/255, 'MarkerSize', 8, 'LineWidth', 2, 'MarkerFace', [0,255,255]/255);
                figure(2);
                hold on;
                plot(one_seg2(:,1), one_seg2(:,2), '.', 'Color', [50,205,50]/255);%
                plot(one_seg2(1,1), one_seg2(1,2), 'o', 'Color',  [0,255,255]/255, 'MarkerSize', 8, 'LineWidth', 2, 'MarkerFace', [0,255,255]/255);
                plot(one_seg2(end,1), one_seg2(end,2), 'o', 'Color', [0,255,255]/255, 'MarkerSize', 8, 'LineWidth', 2, 'MarkerFace', [0,255,255]/255);
            end
        end
    end
end
feat2seg_half2 = zeros(num_fp2,1);
for i=1:num_seg_half2
    head = segments_half_fp_index2(i,1);
    feat2seg_half2(head, 1)=i;
end
feat2seg_half1 = zeros(num_fp1,1);
for i=1:num_seg_half1
    head = segments_half_fp_index1(i,1);
    feat2seg_half1(head, 1)=i;
end
num_seg_repeat_half=0;
if flag_seg_half_debug == true
    figure(1);
    imshow(I);
    figure(2);
    imshow(J);
end
count_seg_valid_half2=0;
for i=1:num_seg_half2%
    head2=segments_half_fp_index2(i,1);
    head1 = fp2_to_fp1(head2);
    %---------make sure the points are visible in img1------------------------
    px_head=feature_points2(head2,1);
    py_head=feature_points2(head2,2);
    p2 = [px_head; py_head; 1];
    p1 = Homo_inv*p2;
    p1 = p1/p1(3);
    if p1(1)<=8*gap || p1(1)>=imsz1(2)-8*gap || p1(2)<=gap || p1(2)>=imsz1(1)-gap%if points are too close to the boundary
        if flag_show_boundary == true
            figure(2);
            hold on;
            plot(px_head, py_head, '^r');
        end
        continue;
    end
    count_seg_valid_half2 = count_seg_valid_half2 +1;
%--------------------------check if match and if half segment--------------
    if head1>0
        %it is guaranteed that the segment is visible in the first image
        tag=feat2seg_half1(head1);%no need to check segment_mask2(tail2,head2)
        %check if pair (head tail) is also a half segment in the second image.
        %TODO: need to figure out a way to match half segment.
        if tag>0 
            num_seg_repeat_half=num_seg_repeat_half+1;
            match_segment_half(num_seg_repeat_half,1)=tag;
            match_segment_half(num_seg_repeat_half,2)=i;
            match_segment_half(num_seg_repeat_half,3)=head1;
            match_segment_half(num_seg_repeat_half,4)=head2;
            if flag_seg_half_debug == true
                one_seg_half1 = segments_half1{tag};
                one_seg_half2 = segments_half2{i};
                figure(1);
                hold on;
                plot(one_seg_half1(:,1),one_seg_half1(:,2),'g.');
                plot(feature_points1(head1,1),feature_points1(head1,2),'go');
                figure(2);
                hold on;
                plot(one_seg_half2(:,1),one_seg_half2(:,2),'g.');
                plot(feature_points2(head2,1),feature_points2(head2,2),'go');
                figure(1);
                hold on;
                plot(feature_points1(head1,1),feature_points1(head1,2),'bo');
                plot(one_seg_half1(:,1),one_seg_half1(:,2),'b.');
                figure(2);
                hold on;
                plot(feature_points2(tail2,1),feature_points2(tail2,2),'bo');
                plot(one_seg_half2(:,1),one_seg_half2(:,2),'b.');
            end
        end
    end
end

repeatability = num_seg_repeat/min(num_seg1, count_seg_valid2);
repeatability_half = num_seg_repeat_half/min(num_seg_half1, count_seg_valid_half2);
fprintf('branching segment repeatability: %f\n', repeatability);
fprintf('number of repeated branching segments: %d\n', num_seg_repeat);














