function [is_found, ind_peak] = find_peak(distribution, p_center)
%check and find whether there is a peak in the distribution.
%distribution is a line perpendicular to the vessel direction, doesn't need
%to consider circular

is_found = false;
ind_peak = -1;

thresh_monotonic = 0.0001;
thresh_min_peak=0.02;%this is very sensitive, pay attention
for i=3:length(distribution)-2
    p1=distribution(i-2);
    p2=distribution(i-1);
    p3=distribution(i);
    p4=distribution(i+1);
    p5=distribution(i+2);
    if p1+thresh_monotonic < p2 && p2 <= p3 && p3 >= p4 && p4 > p5+thresh_monotonic && p3 > thresh_min_peak
        is_found = true;
        ind_peak = i;
    end
end