function [img_spec_removed, mask] = remove_specular(I, thresh_specular)
%input: I: image with specular reflection
%output: img_spec_removed: image without specular reflection

if ~exist('thresh_specular','var')
    thresh_specular = 255;
end

[rows, cols] = size(I);
I = double(I);

% init

mask = zeros(rows, cols);% 1 for specular area, 0 not

for i = 1:rows
    for j= 1:cols
        if I(i,j) > thresh_specular/255%170    %it was 170
            mask(i,j) = 1; 
        end
    end
end

se = strel('disk',5);
mask = imdilate(mask, se);%makes the boundary blurry
img_spec_removed = not(mask) .* I;%bright areas are marked as black
