function [match, match_correct,count_match, count_correct, min_value]=calculate_matching_correctness(grayI, ...
    grayJ, feature_points1, feature_points2, points_prj2, Homo, thresh_distance)
%this is to mimic the matching method used in PTAM: constrained SSD
%matching
%obtain affine from homography and add random noise
%warp each patch before SSD matching.
%output:
%match: binary index, the found matches
%match_correct: binary index, the correct found matches
%count_match: the number of found matches
%count_correct: the number of correctly found matches
%TODO: add affine warp with ground truth, ---> finally done.
%TODO: constructing patch1 is slow though
flag_debug_warp = false;
flag_debug = false;
flag_debug_patch = false;
flag_prewarp = false;
flag_use_groundtruth_orientation = false;
flag_branch = false;
num_fp1 = size(feature_points1,1);
num_fp2 = size(feature_points2,1);
imsz1 = size(grayI);
imsz2 = size(grayJ);
radius_orientation = 11;
count_all = 0;%all valid detected points
count_match = 0;%the number of found matches
count_correct = 0;%the number of correctly found matches
patch_size = 21;
border=patch_size*2;
thresh_min_ssd = 0.02;
thresh_match_area = 50;
match = zeros(1,num_fp2);
match_correct = zeros(1,num_fp2);
min_value = zeros(1,num_fp2)-1;
Homo_inv = inv(Homo);%inverse a matrix is slow do it outside of the loop
affine_inv = Homo_inv;%use affine matrix from homo to warp the patch before SSD matching
affine_inv(3,1:2)=0;
if flag_debug == true
    figure(4);
    imshow(grayI);
    figure(5);
    imshow(grayJ);
    im3 = appendimages(grayI,grayJ);
    figure(8);
    colormap('gray');
    imagesc(im3);
    cols1 = size(grayI,2);
end
for j=1:num_fp2
    min_dis=10000;
    min_i = 0;
    qx=feature_points2(j,1);
    qy=feature_points2(j,2);
    qx = floor(qx);
    qy = floor(qy);
    tmp = Homo\[qx qy 1]';
    tmp = tmp/tmp(3);
    if ~(qx < imsz2(2)-border && qx > border && qy<imsz2(1)-border && qy>border...
            && tmp(1) < imsz1(2)-border && tmp(1) > border && tmp(2)<imsz1(1)-border && tmp(2)>border)
        continue;%make sure each point's inverse in I is not at the boundary
    end
    count_all = count_all +1;
    %--------------construct the patch in the second image
    if flag_prewarp == true
        if flag_use_groundtruth_orientation == true
            u = [1; 0];
            v = [-u(2); u(1)];
            p1 = [px + u(1)*radius_orientation; py+u(2)*radius_orientation; 1];%use vector [1,0]
            tmp = Homo*p1;
            p2 = tmp/tmp(3);
            vec1 = [p2(1)-rx; p2(2)-ry];
            vec1 = vec1/norm(vec1);
            vec2 = [-vec1(2); vec1(1)];
        end
        if flag_debug==true && flag_debug_warp == true
            figure(5);
            hold on;
            plot(rx, ry, '*r');
            plot(rx+vec1(1)*radius_orientation, ry+vec1(2)*radius_orientation, '.r');
            plot(rx+vec2(1)*radius_orientation, ry+vec2(2)*radius_orientation, '.w');
            plot(p2(1), p2(2), '.g');
            %plot(ridges_prj2(1,i), ridges_prj2(2,i), '.g');
        end
        patch2 = zeros(patch_size,patch_size);
        for m=1:patch_size%attention, m is column, n is row
            for n=1:patch_size
                p = [qx; qy]-(floor((patch_size-1)/2))*vec1-(floor((patch_size-1)/2))*vec2 + (n-1)*vec1+(m-1)*vec2;
                p = floor(p);
                patch2(n,m)=grayJ(p(2), p(1));
                if flag_debug==true && flag_debug_warp == true && flag_debug_patch == true%remove soon
                    figure(5);
                    hold on;
                    plot(rx, ry,'r*');
                    plot(qx, qy,'g*');
                    plot(ridge_points2(j,1), ridge_points2(j,2), 'g.');
                    plot(p(1), p(2),'.b');
                end
            end
        end
    else
        %patch2 = interp2(grayJ, (qx-patch_size):(qx+patch_size) );
        patch2 = grayJ(floor(qy-(patch_size-1)/2):floor(qy+(patch_size-1)/2), floor(qx-(patch_size-1)/2):floor(qx+(patch_size-1)/2));%might be out of border
    end
    patch2 = (patch2-mean(mean(patch2)))/norm(patch2);
    for i=1:num_fp1
        px=feature_points1(i,1);%each row is a point
        py=feature_points1(i,2);
        rx=points_prj2(1,i);%each column is a point
        ry=points_prj2(2,i);
        if ~(px < imsz1(2)-border && px > border && py<imsz1(1)-border && py>border...
                && rx < imsz2(2)-border && rx > border && ry<imsz2(1)-border && ry>border)
            continue;%make sure each point has a patch in the image
        end
        if sqrt((rx-qx)*(rx-qx)+(ry-qy)*(ry-qy)) < thresh_match_area
        %--------------construct the patch in the first image
            if flag_prewarp == true
                if flag_use_groundtruth_orientation == true%used ground truth direction
                    u = [1; 0];
                    v = [-u(2); u(1)];
                end
                if flag_debug==true && flag_debug_warp == true
                    figure(4);
                    hold on;
                    plot(px, py, 'g*');
                    plot(px+radius_orientation*u(1), py+radius_orientation*u(2), 'g.');
                end
                patch1 = zeros(patch_size,patch_size);
                for n=1:patch_size %attention n is column, m is row 
                    for m=1:patch_size
                        p = [px; py]-(floor((patch_size-1)/2))*u-(floor((patch_size-1)/2))*v + (n-1)*u+(m-1)*v;
                        p = floor(p);
                        patch1(m,n)=grayI(p(2), p(1));
                        if flag_debug==true && flag_debug_warp == true && flag_debug_patch == true%remove soon
                            figure(4);
                            hold on;
                            plot(p(1), p(2),'.b');
                        end
                    end
                end
            else
                patch1 = zeros(patch_size,patch_size);
                tmp=affine_inv*[rx;ry;1];%the homogeneous mapping is dependent on the position, which means different 
                %points in Image J have different local mappings
                patch_center = tmp/tmp(3);
                offset_patch = [px;py;1]-patch_center;
                for n=1:patch_size;%-(patch_size-1)/2:(patch_size-1)/2% 1:patch_size %column major 
                    for m=1:patch_size;%-(patch_size-1)/2:(patch_size-1)/2
                        p = [rx-(patch_size-1)/2+n-1;ry-(patch_size-1)/2+m-1];
                        tmp = affine_inv*[p(1); p(2); 1];
                        q = tmp/tmp(3);
                        q = q + offset_patch;
                        q = floor(q+0.5);
                        if q(2)>imsz1(1)
                            q(2) = imsz1(1);
                        end
                        if q(2)<1
                            q(2) = 1;
                        end
                        if q(1)>imsz1(2)
                            q(1) = imsz1(2);
                        end
                        if q(2)<1
                            q(2) = 1;
                        end
                        patch1(m,n) = grayI(q(2),q(1));
                        if flag_debug == true && flag_debug_warp == true && flag_debug_patch == true%remove soon
                            figure(4);
                            hold on;
                            plot(q(1), q(2),'.b');
                        end
                    end
                end
                %patch1 = grayI(floor(py-(patch_size-1)/2):floor(py+(patch_size-1)/2), floor(px-(patch_size-1)/2):floor(px+(patch_size-1)/2));
                %patch1 = grayJ(floor(ry-(patch_size-1)/2):floor(ry+(patch_size-1)/2), floor(rx-(patch_size-1)/2):floor(rx+(patch_size-1)/2));
            end
            patch1 = (patch1-mean(mean(patch1)))/norm(patch1);
            %------------------upon here, all needed is patch1 and patch2
            dis_ssd = sum(sum((patch1 - patch2).*(patch1 - patch2)));
            if dis_ssd < min_dis
                min_dis = dis_ssd;
                min_i = i;
            end
        end
    end
    if min_i~=0 && min_dis < thresh_min_ssd
        match(j) = min_i;
        count_match = count_match +1;
        px=feature_points1(min_i,1);
        py=feature_points1(min_i,2);
        rx=points_prj2(1,min_i);
        ry=points_prj2(2,min_i);
        dis = sqrt((rx-qx)*(rx-qx)+(ry-qy)*(ry-qy));
        if dis<thresh_distance
            if flag_debug == true
                figure(4);
                hold on;
                plot(px, py, 'g*');
                figure(5);
                hold on;
                plot(rx, ry,'r*');
                plot(qx, qy,'g*');
                figure(8);
                hold on;
                line([px qx+cols1], ...
                     [py qy], 'Color', 'c');
                if flag_branch == true
                    diff(i,1:4) = angles_inbetween1(i,1:4);
                    diff(i,5:8) = angles_inbetween2(min_i,1:4);
                    figure(4);
                    hold on;
                    plot(ridge_points1(i,[1]), ridge_points1(i,[2]), 'g.');
                    plot(px+radius_orientation*cos(angles1(i,1)/180*pi), py-radius_orientation*sin(angles1(i,1)/180*pi), 'r.');
                    figure(5);
                    hold on;
                    plot(ridge_points2(min_i,[1]), ridge_points2(min_i,[2]), 'g.');
                    plot(qx+radius_orientation*cos(angles2(min_i,1)/180*pi), qy-radius_orientation*sin(angles2(min_i,1)/180*pi), 'r.');
                    v1=[ridge_points1(i,1)-px, ridge_points1(i,2)-py];
                    v2=[ridge_points1(i,3)-px, ridge_points1(i,4)-py];
                    v3=[ridge_points1(i,5)-px, ridge_points1(i,6)-py];
                    theta1= acos(v1*v2'/(norm(v1)*norm(v2)))/pi*180;%angle of ridge-point vector
                    theta2= acos(v2*v3'/(norm(v2)*norm(v3)))/pi*180;%compare with recorded angle, error is within 5 degrees
                    theta3= acos(v3*v1'/(norm(v3)*norm(v1)))/pi*180;
                    u1=[ridge_points2(min_i,1)-qx, ridge_points2(min_i,2)-qy];
                    u2=[ridge_points2(min_i,3)-qx, ridge_points2(min_i,4)-qy];
                    u3=[ridge_points2(min_i,5)-qx, ridge_points2(min_i,6)-qy];
                    gamma1= acos(u1*u2'/(norm(u1)*norm(u2)))/pi*180;
                    gamma2= acos(u2*u3'/(norm(u2)*norm(u3)))/pi*180;
                    gamma3= acos(u3*u1'/(norm(u3)*norm(u1)))/pi*180;
                    theta = [theta1, theta2, theta3];
                    gamma = [gamma1, gamma2, gamma3];
                    error = theta-gamma;   %error caused by inaccuracy of ridge detection: 0.5~50   average 30 degree
                    figure(5);
                    hold on;
                    plot(qx+vec1(1)*radius_orientation, qy+vec1(2)*radius_orientation, '.b');
                end
            end
            min_value(j)=min_dis;
            match_correct(j) = min_i;
            count_correct = count_correct+1;
        end
    end
end
fprintf('Correctly matched points: %d\n', count_correct);
fprintf('Total matched points: %d\n', count_match);
fprintf('Correctness: %f\n', count_correct/count_match);



