function [corners_new,scores_new]= nonmax_suppression_general(corners, scores, win_half, imsz)
%corners: n*2, 1st column x, 2nd column y
%scores: n*1
%win_half: half of the window
num_corners = length(scores);
%construct the neighbor and put in one dimension
win = 2*win_half+1;
gx = meshgrid(1:win,1:win)-(win_half+1);
gy = gx';
offsets=gx*imsz(1)+gy;
offsets=reshape(offsets,1,[]);
offsets((length(offsets)+1)/2)=1;  


imsz = imsz(1:2);   
rcorners=zeros(size(corners));
rscores=zeros(size(scores));
num_nonmax=0;

score_image = -ones(imsz);

score_image(sub2ind(imsz, floor(corners(:,2)), floor(corners(:,1)))) = scores;

max_score = 10000;

for i=1:num_corners
    pos = sub2ind(imsz, floor(corners(i,2)), floor(corners(i, 1)));
    if corners(i,1)<=win_half+1 || corners(i,2)<=win_half+1 || corners(i,1)>=imsz(2)-win_half-1 ||corners(i,2)>=imsz(1)-win_half-1
        continue;%points close to the border are discarded
    end
    if all(score_image(pos) >= score_image(pos + offsets))
        num_nonmax = num_nonmax+1;
        rcorners(num_nonmax,:) = corners(i,:);
        rscores(num_nonmax) = scores(i);
        score_image(pos) = max_score;%mark this point with highest score so that nearby points will be discarded.
    end
end

corners_new = rcorners(1:num_nonmax, :);
scores_new = rscores(1:num_nonmax);


end