function [feature_points, cornerness]= read_anisotropic_file(file_name)
%read feature points out from sofka file
%file_name: the file contains the feature points deteced from anisotropic
%feature detector.
%feature_points: n*3 each row stores one feautre point [x,y, theta]
%win_half: the size of half window used for non-maximum suppression
feature_points = [];
fid = fopen(file_name);
line = fgetl(fid);
i=1;
while(~feof(fid))
    line = fgetl(fid);
    data = sscanf(line, '%d %d %f %f %f %f %f %f %f\n');
    feature_points(i,1) = data(1);
    feature_points(i,2) = data(2);
    feature_points(i,3) = data(end);
    cornerness(i,1) = data(6);
    i=i+1;
end
fclose(fid);
        
        
        
        
        
        
        
        
        
        
        
        