function feature_points = read_sofka_file(file_name)
%read feature points out from sofka file
%file_name: the file contains the landmarks deteced from sofka's vessel
%detector.
%feature_points: n*2 each row stores one feautre point [x,y]

fid = fopen(file_name);
line = fgetl(fid);
while(~strcmp(line(1:min(length(line),13)),'landmarks = {'))
    line = fgetl(fid);
end
line = fgetl(fid);
vec_num = sscanf(line, 'vec_num = %d\n');
for i=1:vec_num
    line = fgetl(fid);
    id = sscanf(line, 'vec_element_%d = {\n');
    line = fgetl(fid);
    group_id = sscanf(line, 'prrepl_landmark: group id = %d\n');
    line = fgetl(fid);
    radius = sscanf(line, '                     radius = %d\n');
    line = fgetl(fid);
    location = sscanf(line, '                   location = %f %f\n');
    line = fgetl(fid);
    line = fgetl(fid);
    feature_points(i,:)=location;
end
fclose(fid);