function visualization_test_accuracy(Ivessel, Jvessel, feature_points1, feature_points2, points_prj2, ...
    index_det, index_prj, index_large_error, Homo)
%visualization tool for manual testing the accuracy
Homo = inv(Homo);

figure(14);
imshow(Ivessel, [0 0.1]);
hold on;
plot(feature_points1(:,1), feature_points1(:,2), 'bo', 'MarkerSize',5, 'LineWidth',3);
figure(15);
imshow(Jvessel, [0 0.1]);
hold on;
plot(feature_points2(:,1), feature_points2(:,2), 'bo', 'MarkerSize',5, 'LineWidth',3);%blue, not repeat
plot(feature_points2(index_det,1), feature_points2(index_det,2), 'go', 'MarkerSize',5, 'LineWidth',3);%green repeat
plot(points_prj2(1,index_prj), points_prj2(2,index_prj),'*r'); %ground truth
plot(feature_points2(index_large_error,1), feature_points2(index_large_error,2), 'o', 'MarkerSize',5, 'LineWidth',3, 'Color', 'c');%repeat but with large error

ox = xlim;     % get original x limit
oy = ylim;     % get original y limit
xlim('auto');  % zoom out to x max
ylim('auto');  % zoom out to y max
xmax = xlim;   % get max x 
ymax = ylim;   % get max y
xlim(ox);      % restore x limit
ylim(oy);      % restore y limit

if exist('style') == 0
    style = 'fullcross';
end

set(gcf,'pointer', style);  % use fullcross, user can change this

if exist('n') == 0
    n = 100000;
end
flag_break = false;
for i = 1:n
    while 1
        k = waitforbuttonpress;
        point1 = get(gca,'CurrentPoint');    % button down detected
        finalRect = rbbox;                   % return figure units
        point2 = get(gca,'CurrentPoint');    % button up detected
        point1 = point1(1,1:2);              % extract x and y
        point2 = point2(1,1:2);                
        if sum(point1 == point2) == 2        % same points
            if  k == 1                       % detects a key press
                x(i) = point1(1);
                y(i) = point1(2);
                button(i) = double(get(gcf,'CurrentCharacter'));   % get keyboad ascii number
                if n == 100000 & button(i) == 13                   % n is not assigned and press Enter(13) -> exit       
                    % compatible with ginput
                    x = x(1:end-1);
                    y = y(1:end-1);
                    button = button(1:end-1);
                end
                if button(i) == 27
                    flag_break = true;
                    break;
                end
            else                             % detects a mouse button press
                x(i) = point1(1);
                y(i) = point1(2);
                p1 = [x(i); y(i); 1];
                figure(15);
                hold on;
                plot(p1(1), p1(2), '.g');
                drawnow;
                p2=Homo*p1;
                p2=p2./p2(3);
                %p2 = p2+shift;%shift the offset
                x2(i) = p2(1);
                y2(i) = p2(2);
                figure(14);
                hold on;
                plot(p2(1), p2(2), '.g');
                drawnow; 
                figure(15);
                switch get(gcf,'SelectionType')
                    case 'normal'            % left button
                        button(i) = 1;
                    case 'extend'            % middle button
                        button(i) = 2;
                    case 'alt'               % right button
                        button(i) = 3;
                end
            end
            break;
        end
        offset = (point2-point1);           
        if offset(1) > 0 & offset(2) < 0     % drag left-top to right-down -> zoom in
            xlim([point1(1) point2(1)]);
            ylim([point2(2) point1(2)]);
        end         
        if offset(1) < 0 & offset(2) > 0     % drag right-down to left-top -> zoom out
            xlim(xmax);
            ylim(ymax);
        end
    end
    if i == n        
        break;
    end
    if flag_break == true
        break;
    end
end




